import { App, Decorator, Entities, Method } from './types';
export interface Route<TSchema> {
    deprecated: Decorator['$deprecated'];
    description?: string;
    method: Method;
    path: string;
    permissions: string[];
    schema?: TSchema;
    responseSchema?: TSchema;
    source?: {
        filename: string;
        lineNumber: number;
    };
    successStatus: number;
    summary: string;
}
declare const analyzeApp: <TEntities extends Entities, TSchema>(getApp: () => App<TEntities, TSchema>) => Route<TSchema>[];
export declare const analyzeFile: (absolutePathToApp: string) => Route<{}>[];
export declare const removeScope: <TSchema>(schema: TSchema) => TSchema;
export default analyzeApp;
