import { Request } from 'express';
import { Entities, Middleware } from './types';
declare type Method = 'CONNECT' | 'DELETE' | 'GET' | 'HEAD' | 'OPTIONS' | 'PATCH' | 'POST' | 'PUT' | 'TRACE';
declare type PathGetter = string | ((r: Request) => string);
declare type BodyGetter = (r: Request) => any;
export declare const forImpl: (path: PathGetter, method?: "CONNECT" | "DELETE" | "GET" | "HEAD" | "OPTIONS" | "PATCH" | "POST" | "PUT" | "TRACE" | ((r: Request) => Method) | undefined) => Middleware<Entities>;
export declare const endpoint: Middleware<Entities>;
export declare const redirect: (path: PathGetter, status?: number) => Middleware<Entities>;
export declare const rewrite: (method: Method, path: PathGetter, getBody?: BodyGetter | undefined) => Middleware<Entities>;
export declare const deprecate: {
    endpoint: Middleware<Entities>;
    for: (path: PathGetter, method?: "CONNECT" | "DELETE" | "GET" | "HEAD" | "OPTIONS" | "PATCH" | "POST" | "PUT" | "TRACE" | ((r: Request) => Method) | undefined) => Middleware<Entities>;
    redirect: (path: PathGetter, status?: number) => Middleware<Entities>;
    rewrite: (method: Method, path: PathGetter, getBody?: BodyGetter | undefined) => Middleware<Entities>;
};
export {};
