"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const decorate_1 = require("./decorate");
const pathWith = (getter, req) => typeof getter === 'function' ? getter(req) : getter;
const methodWith = (getter, req) => typeof getter === 'function' ? getter(req) : getter;
exports.forImpl = (path, method) => decorate_1.decorate({ $deprecated: 'in-use' }, (req, res, next) => {
    const methodGetter = method || req.method;
    const actualPath = pathWith(path, req);
    const actualMethod = methodWith(methodGetter, req).toUpperCase();
    res.set('Deprecated-For', `${actualMethod} ${actualPath}`);
    next();
});
exports.endpoint = decorate_1.decorate({ $deprecated: 'in-use' }, (_, res, next) => {
    res.set('Deprecated', 'true');
    next();
});
exports.redirect = (path, status = 302) => decorate_1.decorate({ $deprecated: 'redirect' }, (req, res, _) => {
    const actualPath = pathWith(path, req);
    res.set('Deprecated-For', `GET ${actualPath}`);
    res.redirect(status, actualPath);
});
exports.rewrite = (method, path, getBody) => {
    const pathGetter = typeof path === 'function'
        ? path
        : () => path;
    return decorate_1.decorate({ $deprecated: 'rewrite' }, (req, res, next) => {
        const actualPath = pathWith(pathGetter, req);
        res.set('Deprecated-For', `${method} ${actualPath}`);
        req.method = method;
        req.url = actualPath;
        if (getBody)
            req.body = getBody(req);
        next();
    });
};
exports.deprecate = {
    endpoint: exports.endpoint,
    for: exports.forImpl,
    redirect: exports.redirect,
    rewrite: exports.rewrite,
};
//# sourceMappingURL=deprecate.js.map