"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class CustomError extends Error {
    constructor(statusCode, error, extra) {
        super('CustomError');
        this.statusCode = statusCode;
        this.error = error;
        this.extra = extra
            ? Object.assign({}, extra) : {};
    }
}
exports.CustomError = CustomError;
const createError = (statusCode) => (error, extra) => new CustomError(statusCode, error, extra);
exports.badRequest = createError(400);
exports.custom = (statusCode, error, extra) => createError(statusCode)(error, extra);
exports.forbidden = createError(403);
exports.internalServerError = createError(500);
exports.notFound = createError(404);
exports.unauthorized = createError(401);
//# sourceMappingURL=error.js.map