import { Entities, Req as Request } from '../types';
interface LoadAdditionalModels<TEntities extends Entities, TModel> {
    key: string;
    fn: (req: Req<TEntities>, model: TModel) => Promise<void>;
}
declare type Req<TEntities extends Entities> = Request<TEntities, keyof TEntities>;
interface Requires {
    $requires?: string[];
}
interface GetIdFrom<TEntities extends Entities, TId> extends Requires {
    (req: Req<TEntities>): TId;
}
interface GetModelFrom<TEntities extends Entities, TKey extends keyof TEntities> extends Requires {
    (req: Req<TEntities>): Promise<Req<TEntities>[TKey] | null | undefined>;
}
interface GetModelById<TEntities extends Entities, TKey extends keyof TEntities, TId extends keyof TEntities[TKey]> {
    (id: TEntities[TKey][TId]): Promise<Req<TEntities>[TKey] | null | undefined>;
}
export declare const loadFromRequest: <TEntities extends Entities, TKey extends keyof TEntities>(getModelFromRequest: GetModelFrom<TEntities, TKey>, storeModelInto: TKey, loadAdditionalModels?: LoadAdditionalModels<TEntities, Request<TEntities, keyof TEntities>[TKey]> | undefined) => import("../types").Middleware<TEntities>;
export declare const loadOnlyOnce: <TEntities extends Entities, TKey extends keyof TEntities, TId extends keyof TEntities[TKey]>(getIdFromModel: (model: Request<TEntities, keyof TEntities>[TKey]) => TEntities[TKey][TId]) => (getModelFromRequest: GetModelFrom<TEntities, TKey>, getIdFromRequest: GetIdFrom<TEntities, TEntities[TKey][TId]>, storeModelInto: TKey) => GetModelFrom<TEntities, TKey>;
export declare const loadWith: <TEntities extends Entities, TKey extends keyof TEntities, TId extends keyof TEntities[TKey]>(fetch: GetModelById<TEntities, TKey, TId>, getIdFromModel: (model: Request<TEntities, keyof TEntities>[TKey]) => TEntities[TKey][TId]) => (getIdFromRequest: GetIdFrom<TEntities, TEntities[TKey][TId]>, storeModelInto: TKey, loadAdditionalModels?: LoadAdditionalModels<TEntities, Request<TEntities, keyof TEntities>[TKey]> | undefined) => import("../types").Middleware<TEntities>;
export declare const loadOnceWith: <TEntities extends Entities, TKey extends keyof TEntities, TId extends keyof TEntities[TKey]>(getIdFromModel: (model: Request<TEntities, keyof TEntities>[TKey]) => TEntities[TKey][TId]) => (getModelFromRequest: GetModelFrom<TEntities, TKey>, getModelIdFromRequest: (model: Request<TEntities, keyof TEntities>) => TEntities[TKey][TId], storeModelInto: TKey, requiredModels?: string[] | undefined, loadAdditionalModels?: LoadAdditionalModels<TEntities, Request<TEntities, keyof TEntities>[TKey]> | undefined) => import("../types").Middleware<TEntities>;
export {};
