import { Entities, Middleware } from '../types';
export declare type PermissionFn<TEntities> = (arg: TEntities) => boolean;
export declare type PermissionSpec<TEntities> = PermissionFn<TEntities> | PermissionEntity<TEntities> | (PermissionFn<TEntities> & PermissionEntity<TEntities>);
export declare const isPermissionFn: <TEntities>(spec: PermissionSpec<TEntities>) => spec is PermissionFn<TEntities>;
export declare const isPermissionEntity: <TEntities>(spec: PermissionSpec<TEntities>) => spec is PermissionEntity<TEntities>;
export interface PermissionEntity<TEntities> {
    [key: string]: PermissionSpec<TEntities>;
}
export declare type PermissionMap<TEntities> = {
    [K in keyof TEntities]?: PermissionEntity<TEntities>;
};
export declare type Mapping<TEntities> = {
    [K in keyof TEntities]?: string;
};
export declare type CanFn<TEntities extends Entities> = (mapping?: Mapping<TEntities>) => Middleware<TEntities>;
export declare type CanItem<TEntities extends Entities> = CanFn<TEntities> & {
    [subaction: string]: CanFn<TEntities>;
} & {
    $container?: boolean;
};
export declare type CanAction<TEntities extends Entities> = {
    [K in keyof TEntities]: CanItem<TEntities>;
};
export interface Can<TEntities extends Entities> {
    [action: string]: CanAction<TEntities>;
}
